package com.huimv.env.controller;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.huimv.common.utils.Result;
import com.huimv.env.service.IAlarm;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.text.ParseException;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@CrossOrigin
@RestController
@RequestMapping("/alarm")
@Slf4j
public class AlarmController {
    @Autowired
    private IAlarm iAlarm;

    @RequestMapping(value = "/getAlarm",method = RequestMethod.GET)
    public Result getAlarmByFarmIdAndDate(@RequestParam(value = "farmId",required = true) Integer farmId,
                                          @RequestParam(value="alarmType",required=false) Integer alarmType,
                                          @RequestParam(value = "alarmDate") String alarmDate,
                                          @RequestParam(value = "pageSize") Integer pageSize,
                                          @RequestParam(value = "pageNo") Integer pageNo) throws ParseException {
        log.info("farmId>>"+farmId);
        log.info("alarmType>>"+alarmType);
        log.info("alarmDate>>"+alarmDate);
        log.info("pageNo>>"+pageNo);
        log.info("pageSize>>"+pageSize);
        //
        return iAlarm.getAlarm(farmId,alarmType,alarmDate,pageNo,pageSize);
    }

}
